"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _copyToClipboard = _interopRequireDefault(require("copy-to-clipboard"));
var _mergeRefs = _interopRequireDefault(require("./utils/mergeRefs"));
var _Copy = require("./icons/Copy");
var _Check = require("./icons/Check");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["children", "className"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var MarkdownRenderer = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var children = props.children,
    className = props.className,
    rest = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded);
  var mdRef = _react["default"].useRef(null);
  (0, _react.useEffect)(function () {
    var _mdRef$current;
    (_mdRef$current = mdRef.current) === null || _mdRef$current === void 0 ? void 0 : _mdRef$current.querySelectorAll('.copy-code-button').forEach(function (el) {
      el.addEventListener('click', function (e) {
        var _el$nextElementSiblin;
        e.preventDefault();
        var code = (_el$nextElementSiblin = el.nextElementSibling) === null || _el$nextElementSiblin === void 0 ? void 0 : _el$nextElementSiblin.value;
        var icon = el.querySelector('.copy-icon-path');
        icon === null || icon === void 0 ? void 0 : icon.setAttribute('d', _Check.iconPath);
        if (code) {
          (0, _copyToClipboard["default"])(code);
        }
        setTimeout(function () {
          icon === null || icon === void 0 ? void 0 : icon.setAttribute('d', _Copy.iconPath);
        }, 2000);
      });
    });
  }, []);
  if (!children) {
    return null;
  }
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", (0, _extends2["default"])({}, rest, {
    ref: (0, _mergeRefs["default"])(mdRef, ref),
    className: (0, _classnames["default"])(className, 'rcv-markdown'),
    dangerouslySetInnerHTML: {
      __html: children
    }
  }));
});
var _default = exports["default"] = MarkdownRenderer;