import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["children", "className"];
import React, { useEffect } from 'react';
import classNames from 'classnames';
import copy from 'copy-to-clipboard';
import mergeRefs from './utils/mergeRefs';
import { iconPath as copyPath } from './icons/Copy';
import { iconPath as checkPath } from './icons/Check';
import { jsx as _jsx } from "react/jsx-runtime";
var MarkdownRenderer = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
    className = props.className,
    rest = _objectWithoutPropertiesLoose(props, _excluded);
  var mdRef = React.useRef(null);
  useEffect(function () {
    var _mdRef$current;
    (_mdRef$current = mdRef.current) === null || _mdRef$current === void 0 ? void 0 : _mdRef$current.querySelectorAll('.copy-code-button').forEach(function (el) {
      el.addEventListener('click', function (e) {
        var _el$nextElementSiblin;
        e.preventDefault();
        var code = (_el$nextElementSiblin = el.nextElementSibling) === null || _el$nextElementSiblin === void 0 ? void 0 : _el$nextElementSiblin.value;
        var icon = el.querySelector('.copy-icon-path');
        icon === null || icon === void 0 ? void 0 : icon.setAttribute('d', checkPath);
        if (code) {
          copy(code);
        }
        setTimeout(function () {
          icon === null || icon === void 0 ? void 0 : icon.setAttribute('d', copyPath);
        }, 2000);
      });
    });
  }, []);
  if (!children) {
    return null;
  }
  return /*#__PURE__*/_jsx("div", _extends({}, rest, {
    ref: mergeRefs(mdRef, ref),
    className: classNames(className, 'rcv-markdown'),
    dangerouslySetInnerHTML: {
      __html: children
    }
  }));
});
export default MarkdownRenderer;